// DialerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Dialer.h"
#include "DialerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDialerDlg dialog

CDialerDlg::CDialerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDialerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialerDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	hRasConn = NULL;
}

void CDialerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialerDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDialerDlg, CDialog)
	//{{AFX_MSG_MAP(CDialerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDialerDlg message handlers

BOOL CDialerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_stMail.SubclassDlgItem(IDC_STATIC_MAIL,this);
	m_stMail.SetURL("mailto:super_wh_lee@163.net");

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	DWORD dwRet, dwSize, dwEntries;
	LPBYTE lpBuffer;

	LPRASENTRYNAME lpRasEntryName = new RASENTRYNAME;
	lpRasEntryName->dwSize = sizeof(RASENTRYNAME);
	dwSize = sizeof(RASENTRYNAME);

	dwRet = RasEnumEntries(NULL, NULL, lpRasEntryName, &dwSize, &dwEntries);
	delete lpRasEntryName;

	lpBuffer = new BYTE[dwSize];
	lpRasEntryName = (LPRASENTRYNAME)lpBuffer;
	lpRasEntryName->dwSize = sizeof(RASENTRYNAME);
	dwRet = RasEnumEntries(NULL, NULL, lpRasEntryName, &dwSize, &dwEntries);

	CComboBox * pComboBox = (CComboBox *)GetDlgItem(IDC_COMBO_CONNECT_ENTRIES);
	if(dwEntries>0)
	{
		for(DWORD i=0; i<dwEntries; lpRasEntryName++, i++)
			pComboBox->AddString(lpRasEntryName->szEntryName);
		pComboBox->SetCurSel(0);
	}
	else
	{
		AfxMessageBox("Ƚ!",MB_OK|MB_ICONERROR);
		SendMessage(WM_CLOSE);
		return FALSE;
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDialerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDialerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDialerDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();

	GetDlgItem(IDOK)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_CONNECT_ENTRIES)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_USERNAME)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_PASSWORD)->EnableWindow(FALSE);
	
	TCHAR lpszEntry[256];
	GetDlgItemText(IDC_COMBO_CONNECT_ENTRIES, lpszEntry, 255);

	RASDIALPARAMS RasDialParams;
	RasDialParams.dwSize = sizeof(RASDIALPARAMS);

	lstrcpy(RasDialParams.szEntryName, lpszEntry);
	lstrcpy(RasDialParams.szPhoneNumber, _T(""));
	lstrcpy(RasDialParams.szCallbackNumber, _T(""));
	GetDlgItemText(IDC_EDIT_USERNAME,RasDialParams.szUserName,UNLEN);
	GetDlgItemText(IDC_EDIT_PASSWORD,RasDialParams.szPassword, PWLEN);

	hRasConn = NULL;
	DWORD dwRet = RasDial(NULL, NULL, &RasDialParams, 0L, (RASDIALFUNC)RasDialFunc, &hRasConn);
	if(dwRet)
	{
		CString	szMsg;
		if(RasGetErrorString((UINT)dwRet, szMsg.GetBuffer(256),256)!=0)
		{
			szMsg.ReleaseBuffer();
			szMsg.Format("δ֪Զ̷ʴ,Ϊ%ld.",dwRet);
		}
		else
			szMsg.ReleaseBuffer();

		CString buf;
		buf.Format("Ϊ%ld.",dwRet);

		szMsg += buf;

        MessageBox(szMsg,"ʧ",MB_OK|MB_ICONSTOP);
		hRasConn = NULL;
		//CDialog::OnCancel();
		GetDlgItem(IDOK)->EnableWindow();
		GetDlgItem(IDC_COMBO_CONNECT_ENTRIES)->EnableWindow();
		GetDlgItem(IDC_EDIT_USERNAME)->EnableWindow();
		GetDlgItem(IDC_EDIT_PASSWORD)->EnableWindow();
		SetDlgItemText(IDC_STATIC_STATUS,"δӣ");
	}
}
LRESULT CDialerDlg::OnRasDialEvent(WPARAM wparam, LPARAM lparam)
{
	CString szMsg;
	CString buf;

	LoadString(AfxGetInstanceHandle(),GetRasConnState((RASCONNSTATE)wparam),buf.GetBuffer(256),256);
	szMsg.ReleaseBuffer();

	SetDlgItemText(IDC_STATIC_STATUS,"");
	SetDlgItemText(IDC_STATIC_STATUS,buf);

	if(lparam)					//ִ
    {
		if(RasGetErrorString((UINT)lparam, szMsg.GetBuffer(256),256)!=0)
		{
			szMsg.ReleaseBuffer();
			szMsg.Format("δ֪Զ̷ʴ,");
		}
		else
			szMsg.ReleaseBuffer();

		//szMsg = buf + "\n" + szMsg;
		buf.Format("Ϊ%ld.",lparam);

		szMsg += buf;

        MessageBox(szMsg,"ʧ",MB_OK|MB_ICONSTOP);
		RasHangUp( hRasConn );
		hRasConn = NULL;
		//CDialog::OnCancel();
		GetDlgItem(IDOK)->EnableWindow();
		GetDlgItem(IDC_COMBO_CONNECT_ENTRIES)->EnableWindow();
		GetDlgItem(IDC_EDIT_USERNAME)->EnableWindow();
		GetDlgItem(IDC_EDIT_PASSWORD)->EnableWindow();
		SetDlgItemText(IDC_STATIC_STATUS,"δӣ");
    }                                                                                                               
    else 
	if(RASCS_DONE&wparam)		//ӳɹ
	{
		//AfxMessageBox("ӳɹ",MB_OK|MB_ICONINFORMATION);
		CDialog::OnOK();          // رնԻ
	}

	return (LRESULT)0;
}
void CDialerDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	if(hRasConn!=NULL)
	{
		RasHangUp( hRasConn );
		hRasConn = NULL;
		GetDlgItem(IDOK)->EnableWindow();
		GetDlgItem(IDC_COMBO_CONNECT_ENTRIES)->EnableWindow();
		GetDlgItem(IDC_EDIT_USERNAME)->EnableWindow();
		GetDlgItem(IDC_EDIT_PASSWORD)->EnableWindow();
		SetDlgItemText(IDC_STATIC_STATUS,"δӣ");
	}
	else
		CDialog::OnCancel();
}

LRESULT CDialerDlg::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(message==WM_RASDIALEVENT)
		return OnRasDialEvent(wParam,lParam);
	else
		return CDialog::DefWindowProc(message, wParam, lParam);
}

UINT CDialerDlg::GetRasConnState(RASCONNSTATE rasconn)
{
	switch( rasconn )
    {
        case RASCS_OpenPort:
            return IDS_OPENPORT;
        case RASCS_PortOpened:
            return IDS_PORTOPENED;            
        case RASCS_ConnectDevice:
            return IDS_CONNECTDEVICE;        
        case RASCS_DeviceConnected:
            return IDS_DEVICECONNECTED;       
        case RASCS_AllDevicesConnected:
            return IDS_ALLDEVICESCONNECTED;   
        case RASCS_Authenticate:
            return IDS_AUTHENTICATE;          
        case RASCS_AuthNotify:
            return IDS_AUTHNOTIFY;            
        case RASCS_AuthRetry:
            return IDS_AUTHRETRY;             
        case RASCS_AuthCallback:
            return IDS_AUTHCALLBACK;          
        case RASCS_AuthChangePassword:
            return IDS_AUTHCHANGEPASSWORD;    
        case RASCS_AuthProject:
            return IDS_AUTHPROJECT;           
        case RASCS_AuthLinkSpeed:
            return IDS_AUTHLINKSPEED;         
        case RASCS_AuthAck: 
            return IDS_AUTHACK;               
        case RASCS_ReAuthenticate:
            return IDS_REAUTHENTICATE;        
        case RASCS_Authenticated:
            return IDS_AUTHENTICATED;         
        case RASCS_PrepareForCallback:
            return IDS_PREPAREFORCALLBACK;    
        case RASCS_WaitForModemReset:
            return IDS_WAITFORMODEMRESET;     
        case RASCS_WaitForCallback:
            return IDS_WAITFORCALLBACK;       
        case RASCS_Interactive:
            return IDS_INTERACTIVE;           
        case RASCS_RetryAuthentication: 
            return IDS_RETRYAUTHENTICATION;            
        case RASCS_CallbackSetByCaller: 
            return IDS_CALLBACKSETBYCALLER;   
        case RASCS_PasswordExpired:
            return IDS_PASSWORDEXPIRED;       
        case RASCS_Connected:
            return IDS_CONNECTED;            
        case RASCS_Disconnected:
            return IDS_DISCONNECTED;          
        default:
            return IDS_UNDEFINED_ERROR;
    }
}
void WINAPI CDialerDlg::RasDialFunc(UINT unMsg, RASCONNSTATE rasconnstate, DWORD dwError)
{
	CDialerDlg * RasDlg = (CDialerDlg*)AfxGetApp()->m_pMainWnd;
	
	RasDlg->PostMessage(WM_RASDIALEVENT,(WPARAM)rasconnstate,(LPARAM)dwError);
}

int CDialerDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	/*
	DWORD dwRet, dwSize, dwEntries;
	LPBYTE lpBuffer;

	LPRASENTRYNAME lpRasEntryName = new RASENTRYNAME;
	lpRasEntryName->dwSize = sizeof(RASENTRYNAME);
	dwSize = sizeof(RASENTRYNAME);

	dwRet = RasEnumEntries(NULL, NULL, lpRasEntryName, &dwSize, &dwEntries);
	delete lpRasEntryName;

	lpBuffer = new BYTE[dwSize];
	lpRasEntryName = (LPRASENTRYNAME)lpBuffer;
	lpRasEntryName->dwSize = sizeof(RASENTRYNAME);
	dwRet = RasEnumEntries(NULL, NULL, lpRasEntryName, &dwSize, &dwEntries);

	CComboBox * pComboBox = (CComboBox *)GetDlgItem(IDC_COMBO_CONNECT_ENTRIES);
	if(dwEntries>0)
	{
		for(DWORD i=0; i<dwEntries; lpRasEntryName++, i++)
			pComboBox->AddString(lpRasEntryName->szEntryName);
		pComboBox->SetCurSel(0);
	}
	else
	{

	}
	*/

	return 0;
}
